package org.injac.oai.format;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;

import org.apache.commons.digester.Digester;


import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class FormatConfig {
	private String metadataPrefix =null;
	private String 	rootTag=null;
	private String 	metadataNamespace=null;
	private String 	schema=null;
	
	private HashMap namespaces = null;
	
	private File formatFile=null;
	private ArrayList mappingList = null;
	public FormatConfig(String formatfile)throws IOException, SAXException {
		if (formatfile != null)
			formatFile = new File(formatfile);
		
		
		if ((formatFile == null)||(!formatFile.exists())) {
			throw new IOException("no format file found :" +formatfile);
		}
		init();
	}
	private void init() throws IOException, SAXException{
		mappingList = new ArrayList();
		namespaces = new HashMap();
		Digester digester = new Digester();
		digester.setValidating(false);
		digester.push(this);
		
		digester.addSetProperties("mapping");
		// parsing mapping
		digester.addObjectCreate("mapping/webdav-metadata/mapping-attr", MappingAttribute.class);
		digester.addSetProperties("mapping/webdav-metadata/mapping-attr");
		digester.addSetNext("mapping/webdav-metadata/mapping-attr", "addMapping");
		
		
		digester.addObjectCreate("mapping/webdav-metadata/mapping-attr/mapping-attr", MappingAttribute.class);
		digester.addSetProperties("mapping/webdav-metadata/mapping-attr/mapping-attr");
		digester.addSetNext("mapping/webdav-metadata/mapping-attr/mapping-attr", "addMapping");
		
		
		// parsing namespaces
		//digester.addObjectCreate("mapping/namespaces/namespace", NameSpace.class);
		//digester.addSetProperties("mapping/namespaces/namespace");
		//digester.addSetNext("mapping/namespaces/namespace","addNamespace");
		
		digester.addCallMethod("mapping/namespaces/namespace","addNamespace",2);
		digester.addCallParam("mapping/namespaces/namespace", 0, "prefix");
		digester.addCallParam("mapping/namespaces/namespace", 1, "uri");
		
		digester.parse(new InputSource( new FileInputStream(formatFile)));
	}
	
	public void addMapping(MappingAttribute mapAttr){
		mappingList.add(mapAttr);
	}
	public String getMetadataNamespace() {
		return metadataNamespace;
	}
	public void setMetadataNamespace(String metadataNamespace) {
		this.metadataNamespace = metadataNamespace;
	}
	public String getMetadataPrefix() {
		return metadataPrefix;
	}
	public void setMetadataPrefix(String metadataPrefix) {
		this.metadataPrefix = metadataPrefix;
	}
	public String getRootTag() {
		return rootTag;
	}
	public void setRootTag(String rootTag) {
		this.rootTag = rootTag;
	}
	public String getSchema() {
		return schema;
	}
	public void setSchema(String schema) {
		this.schema = schema;
	}
/*	
	public void addNamespace(NameSpace ns){
		namespaces.put(ns.getPrefix(), ns.getUri());
	}
*/
	public void addNamespace(String prefix, String uri){
		namespaces.put(prefix, uri);
	}
	public ArrayList getMappingList() {
		return mappingList;
	}
	public HashMap getNamespaces() {
		return namespaces;
	}
}

