package org.injac.oai.format;

import java.util.ArrayList;
/**
 * Composite class for mapping
 * @author Franois Jannin
 *
 */
public class MappingAttribute {
	private String source = "";
	private String dest = "";
	private String attributes = "";
	private String multiParse = "";
	private String required = "";
	private String defaults = "";
	private String group = "";
	private ArrayList mappings = null;
	public MappingAttribute(){
		mappings = new ArrayList();
	}
	
	public String getAttributes() {
		return attributes;
	}
	public void setAttributes(String attributes) {
		this.attributes = attributes;
	}
	public String getDefaults() {
		return defaults;
	}
	public void setDefaults(String defaults) {
		this.defaults = defaults;
	}
	public String getDest() {
		return dest;
	}
	public void setDest(String dest) {
		this.dest = dest;
	}
	public String getGroup() {
		return group;
	}
	public void setGroup(String group) {
		this.group = group;
	}
	public String getMultiParse() {
		return multiParse;
	}
	public void setMultiParse(String multiParse) {
		this.multiParse = multiParse;
	}
	public String getRequired() {
		return required;
	}
	public void setRequired(String required) {
		this.required = required;
	}
	public String getSource() {
		return source;
	}
	public void setSource(String source) {
		this.source = source;
	}
	public void addMapping(MappingAttribute mapAttr){
		mappings.add(mapAttr);
	}

	public MappingAttribute getChild(int index) {
		if(mappings != null)
			return (MappingAttribute) mappings.get(index);
		return null;
	}
	
	public int getChildrenCount(){
		if(mappings != null)
			return mappings.size();
		return -1;
		
	}
}
