/*
 * Created on 29 juin 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.injac.oai.server.crosswalk;

import org.apache.log4j.Logger;
import org.injac.oai.server.crosswalk.WebdavCrosswalk.DestTag;
import org.injac.oai.util.IdentityTransformer;
import org.injac.oai.util.OAITags;
import org.w3c.dom.*;

import java.util.*;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

/**
 * Class for metadata output
 * 
 * @author shoam
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class MetadataDocument {
	/**
	 * Static logger
	 */
	static Logger logger = Logger.getLogger(MetadataDocument.class);

	/**
	 * Root tag for metadata output document
	 */
	private String rootTag;

	/**
	 * Prefix for root element
	 */
	private String prefix;

	/**
	 * Namespace for root element
	 */
	private String namespace;

	/**
	 * prefixes + uris for optionnal prefix/namespaces
	 */
	private HashMap otherNS;

	/**
	 * Schema location for this metadata format
	 */
	private String schema;

	/**
	 * DOM document
	 */
	private Document document = null;

	public MetadataDocument(String rootTag, String metadataPrefix,
			String metadataNamespace, String schema, HashMap nameSpaces) {

		this.rootTag = rootTag;
		this.prefix = metadataPrefix;
		this.namespace = metadataNamespace;
		this.otherNS = nameSpaces;
		this.schema = schema;
		init();

	}

	/**
	 * Build a doc from whole cloth with root tag and xmlns declarations
	 * 
	 */
	private void init() {
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		document = null;
		try {
			DocumentBuilder builder = factory.newDocumentBuilder();
			document = builder.newDocument(); // Create from whole cloth
			Element root = (Element) document.createElement(prefix + ":"
					+ rootTag);
			logger.debug("MetaDataDocument::init : \nrooTag : " + rootTag
					+ "\nprefix :" + prefix + "\nnamespace : " + namespace);
			root.setAttribute("xmlns:" + prefix, namespace);
			// root.setPrefix(prefix);
			Iterator keys = otherNS.keySet().iterator();
			while (keys.hasNext()) {
				String other_prefix = (String) keys.next();
				String other_namespace = (String) otherNS.get(other_prefix);
				root.setAttribute("xmlns:" + other_prefix, other_namespace);
			}
			root.setAttribute("xmlns:xsi", OAITags.XSI_XMLNS);
			root.setAttribute("xsi:schemaLocation", schema);

			document.appendChild(root);
			// root.appendChild( document.createTextNode("Some Text") );
		} catch (ParserConfigurationException pce) {
			// Parser with specified options can't be built
			pce.printStackTrace();
		}
	}

	public Document getDocument() {
		return document;
	}

	/**
	 * Clear all nodes from document, just root element left
	 * 
	 */
	public void clear() {
		Element root = document.getDocumentElement();
		NodeList childs = root.getChildNodes();
		for (int i = 0; i < childs.getLength(); i++)
			root.removeChild(childs.item(i));

		int rest = childs.getLength();
	}

	public void addTag(Object tag) {

	}

	/**
	 * build XML structure from Destination tags
	 * 
	 * @param tagList
	 * @return
	 */
	public void mergeTagList(ArrayList tagList) {
		logger.debug("entering mergeTagList array size = " + tagList.size());

		// sort tags by path depth
		// Collections.sort(tagList);
		int tagIndex = 0;
		Element root = null;
		Element current = null;

		try {
			logger.debug("clear dom doc with root :" + rootTag);
			clear();
			logger.debug("cleared doc :"
					+ IdentityTransformer.TransformToString(document));
			for (tagIndex = 0; tagIndex < tagList.size(); tagIndex++) {
				DestTag tag = (DestTag) tagList.get(tagIndex);
				logger.debug("mergeTagList : \n" + "_____ mergeTagList _____ "
						+ tag);
				root = document.getDocumentElement();
				current = root;
				current = getCreateCurrent(tag, current);

				if (tag.children != null) {

					// remember grouping current
					Element groupRoot = createEmptyElement(tag);
					for (int i = 0; i < tag.children.size(); i++) {
						DestTag subTag = (DestTag) tag.children.get(i);
						Element subCurrent = groupRoot;
						subCurrent = getCreateCurrent(subTag, groupRoot);
						Element leaf = createLeaf(subTag);
						subCurrent.appendChild(leaf);
					}
					current.appendChild(groupRoot);

				} else {
					// non-grouping unique elements
					Element leaf = createLeaf(tag);
					if(leaf!=null){
						current.appendChild(leaf);
					}

				}

			}

		} catch (Exception exp) {
			logger.error(exp.getClass().getName() + " : " + exp.getMessage());
		}

	}

	private Element createLeaf(DestTag tag) {
		try {

			logger.debug("create leaf : " + tag.prefix + ":" + tag.tag
					+ "\tvalue : " + tag.value);

			if ((tag.value == null) || (tag.prefix == null)
					|| (tag.tag == null) || (tag.tag.equals(""))) {
				return null;
			} else {
				Element leaf = document.createElement(tag.prefix + ":"
						+ tag.tag);
				leaf.appendChild(document.createTextNode(tag.value));

				// append attributes
				if (tag.attrMap != null) {
					Iterator attribs = tag.attrMap.keySet().iterator();
					while (attribs.hasNext()) {
						String name = (String) attribs.next();
						String value = (String) tag.attrMap.get(name);
						if ((value == null) || (name == null)
								|| (name.equals(""))) {
							
						}else{
							leaf.setAttribute(name, value);
						}	
					}

				}
				return leaf;
			}

		} catch (Exception e) {
			logger.error("MetadataDocument::createLeaf :"
					+ e.getLocalizedMessage());
			return null;
		}

	}

	private Element createEmptyElement(DestTag tag) {
		logger.debug("create leaf : " + tag.prefix + ":" + tag.tag
				+ "\tvalue : " + tag.value);
		Element leaf = document.createElement(tag.prefix + ":" + tag.tag);

		// append attributes
		if (tag.attrMap != null) {
			Iterator attribs = tag.attrMap.keySet().iterator();
			while (attribs.hasNext()) {
				String name = (String) attribs.next();
				String value = (String) tag.attrMap.get(name);
				leaf.setAttribute(name, value);
			}

		}
		return leaf;
	}

	/**
	 * 
	 * @param tag
	 * @param current
	 * @return
	 */
	private Element getCreateCurrent(DestTag tag, Element current) {
		if (tag.XBaseArray != null) {
			// create the remaining tree
			for (int x = 0; x < tag.XBaseArray.size(); x++) {
				String nodeName = (String) tag.XBaseArray.get(x);
				NodeList nodes = current.getElementsByTagName(tag.prefix + ":"
						+ nodeName);
				// create node if not already existing
				if (nodes == null || nodes.getLength() == 0) {
					logger.debug("create dom element :" + nodeName);
					Element newElement = document.createElement(tag.prefix
							+ ":" + nodeName);
					// newElement.setPrefix(tag.prefix);
					current = (Element) current.appendChild(newElement);
				} else
				// or we reuse the existing one
				{
					current = (Element) nodes.item(0);
				}
			}
		}
		return current;
	}

	public String getDocumentAsString() {
		StringBuffer result = new StringBuffer();
		try {

			result.append(IdentityTransformer.TransformToString(document));
		} catch (Exception e) {
			logger.error(e + " : " + e.getLocalizedMessage());
		}
		// remove xml decl
		int xmlStart = result.indexOf("<?");
		if (xmlStart != -1) {
			result.replace(xmlStart, result.indexOf(">") + 1, "");
		}
		return result.toString();

	}
}
